/*
 * This file and its contents are supplied under the terms of the
 * Common Development and Distribution License ("CDDL"), version 1.0.
 * You may only use this file in accordance with the terms of version
 * 1.0 of the CDDL.
 *
 * A full copy of the text of the CDDL should have accompanied this
 * source.  A copy of the CDDL is also available via the Internet at
 * http://www.illumos.org/license/CDDL.
 */

/*
 * Copyright 2013 Damian Bogel. All rights reserved.
 */

#ifndef _LIBFSD_H
#define	_LIBFSD_H

#include <sys/fsd.h>

#ifdef __cplusplus
extern "C" {
#endif

extern __thread int fsd_errno;

#define	EFSD_NOERROR			0
#define	EFSD_BAD_STAT			1
#define	EFSD_INTERNAL			2
#define	EFSD_CANT_OPEN_DRIVER		3
#define	EFSD_CANT_OPEN_MOUNTPOINT	4
#define	EFSD_ENTRY_NOT_FOUND		5
#define	EFSD_FAULT			6
#define	EFSD_UNKNOWN_ERROR		7

extern const char *fsd_strerr(int e);

extern int fsd_open();
extern void fsd_close(int fd);

extern int fsd_enable(int fd);
extern int fsd_disable(int fd);

extern int fsd_disturb(int fd, const char *mntpt_path, fsd_stat_t *stat);
extern int fsd_disturb_off(int fd, const char *mntpt_path);

extern int fsd_newdisturb(int fd, fsd_stat_t *stat);
extern int fsd_newdisturb_off(int fd);

#ifdef __cplusplus
}
#endif

#endif /* _LIBFSD_H */
